version: '3'

services:
  db:
    container_name: "{{ service_cfg.name }}_db"
    image: mariadb
    command: --transaction-isolation=READ-COMMITTED --log-bin=binlog --binlog-format=ROW
    restart: always
    volumes:
      - "{{ service_cfg.directory }}/db:/var/lib/mysql:rw"
    environment:
      - MYSQL_ROOT_PASSWORD={{ service_cfg.db.root_password }}
      - MYSQL_DATABASE={{ service_cfg.db.name }}
      - MYSQL_USER={{ service_cfg.db.username }}
      - MYSQL_PASSWORD={{ service_cfg.db.password }}
      - MARIADB_AUTO_UPGRADE=1
      - MARIADB_DISABLE_UPGRADE_BACKUP=1
    labels:
      - "com.centurylinklabs.watchtower.enable=true"

  redis:
    container_name: "{{ service_cfg.name }}_redis"
    image: redis:alpine
    restart: always
    labels:
      - "com.centurylinklabs.watchtower.enable=true"

  nextcloud:
    image: nextcloud:fpm-alpine
    container_name: "{{ service_cfg.name }}_nextcloud"
    restart: always
    environment:
      - MYSQL_ROOT_PASSWORD={{ service_cfg.db.root_password }}
      - MYSQL_DATABASE={{ service_cfg.db.name }}
      - MYSQL_USER={{ service_cfg.db.username }}
      - MYSQL_PASSWORD={{ service_cfg.db.password }}
      - MYSQL_HOST=db
      - REDIS_HOST=redis
    volumes:
      - "{{ service_cfg.directory }}/nextcloud:/var/www/html"
      - "{{ service_cfg.directory }}/php.ini:/usr/local/etc/php/conf.d/php.ini:ro"
    depends_on:
      - db
      - redis

  nginx:
    image: nginx:alpine
    container_name: "{{ service_cfg.name }}_nginx"
    restart: always
    volumes:
      - "{{ service_cfg.directory }}/nginx.conf:/etc/nginx/conf.d/default.conf:ro"
      - "{{ service_cfg.directory }}/nextcloud:/var/www/html:z,ro"
    depends_on:
      - db
      - nextcloud
    labels: *base_labels
    networks: *base_networks
